/* Portal.c generated by valac 0.56.17, the Vala compiler
 * generated from Portal.vala, do not modify */

/*
 * SPDX-FileCopyrightText: 2024 elementary, Inc. (https://elementary.io)
 * SPDX-License-Identifier: LGPL-2.1-or-later
 *
 * Authored by: Leonhard Kargl <leo.kargl@proton.me>
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	SCREEN_CAST_SOURCE_TYPE_MONITOR = 1,
	SCREEN_CAST_SOURCE_TYPE_WINDOW = 2,
	SCREEN_CAST_SOURCE_TYPE_VIRTUAL = 4
} ScreenCastSourceType;

#define SCREEN_CAST_TYPE_SOURCE_TYPE (screen_cast_source_type_get_type ())
typedef enum  {
	SCREEN_CAST_CURSOR_MODE_HIDDEN = 1,
	SCREEN_CAST_CURSOR_MODE_EMBEDDED = 2,
	SCREEN_CAST_CURSOR_MODE_METADATA = 4
} ScreenCastCursorMode;

#define SCREEN_CAST_TYPE_CURSOR_MODE (screen_cast_cursor_mode_get_type ())

#define SCREEN_CAST_TYPE_PORTAL (screen_cast_portal_get_type ())
#define SCREEN_CAST_PORTAL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SCREEN_CAST_TYPE_PORTAL, ScreenCastPortal))
#define SCREEN_CAST_PORTAL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SCREEN_CAST_TYPE_PORTAL, ScreenCastPortalClass))
#define SCREEN_CAST_IS_PORTAL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SCREEN_CAST_TYPE_PORTAL))
#define SCREEN_CAST_IS_PORTAL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SCREEN_CAST_TYPE_PORTAL))
#define SCREEN_CAST_PORTAL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SCREEN_CAST_TYPE_PORTAL, ScreenCastPortalClass))

typedef struct _ScreenCastPortal ScreenCastPortal;
typedef struct _ScreenCastPortalClass ScreenCastPortalClass;
typedef struct _ScreenCastPortalPrivate ScreenCastPortalPrivate;

#define SCREEN_CAST_TYPE_SESSION (screen_cast_session_get_type ())
#define SCREEN_CAST_SESSION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SCREEN_CAST_TYPE_SESSION, ScreenCastSession))
#define SCREEN_CAST_SESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SCREEN_CAST_TYPE_SESSION, ScreenCastSessionClass))
#define SCREEN_CAST_IS_SESSION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SCREEN_CAST_TYPE_SESSION))
#define SCREEN_CAST_IS_SESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SCREEN_CAST_TYPE_SESSION))
#define SCREEN_CAST_SESSION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SCREEN_CAST_TYPE_SESSION, ScreenCastSessionClass))

typedef struct _ScreenCastSession ScreenCastSession;
typedef struct _ScreenCastSessionClass ScreenCastSessionClass;
enum  {
	SCREEN_CAST_PORTAL_0_PROPERTY,
	SCREEN_CAST_PORTAL_AVAILABLE_SOURCE_TYPES_PROPERTY,
	SCREEN_CAST_PORTAL_AVAILABLE_CURSOR_MODES_PROPERTY,
	SCREEN_CAST_PORTAL_VERSION_PROPERTY,
	SCREEN_CAST_PORTAL_NUM_PROPERTIES
};
static GParamSpec* screen_cast_portal_properties[SCREEN_CAST_PORTAL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block6Data Block6Data;
typedef struct _Block7Data Block7Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ScreenCastPortalCreateSessionData ScreenCastPortalCreateSessionData;
typedef struct _ScreenCastPortalSelectSourcesData ScreenCastPortalSelectSourcesData;

#define SCREEN_CAST_SESSION_TYPE_PIPE_WIRE_STREAM (screen_cast_session_pipe_wire_stream_get_type ())
typedef struct _ScreenCastSessionPipeWireStream ScreenCastSessionPipeWireStream;
typedef struct _Block8Data Block8Data;
typedef struct _ScreenCastPortalStartData ScreenCastPortalStartData;
typedef struct _ScreenCastPortalCreateSessionReadyData ScreenCastPortalCreateSessionReadyData;
typedef struct _ScreenCastPortalSelectSourcesReadyData ScreenCastPortalSelectSourcesReadyData;
typedef struct _ScreenCastPortalStartReadyData ScreenCastPortalStartReadyData;

struct _ScreenCastPortal {
	GObject parent_instance;
	ScreenCastPortalPrivate * priv;
};

struct _ScreenCastPortalClass {
	GObjectClass parent_class;
};

struct _ScreenCastPortalPrivate {
	ScreenCastSourceType _available_source_types;
	ScreenCastCursorMode _available_cursor_modes;
	guint _version;
	GDBusConnection* connection;
	GHashTable* sessions;
};

struct _Block6Data {
	int _ref_count_;
	ScreenCastPortal* self;
	char* session_handle;
	gpointer _async_data_;
};

struct _Block7Data {
	int _ref_count_;
	Block6Data * _data6_;
	guint session_register_id;
};

struct _ScreenCastPortalCreateSessionData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ScreenCastPortal* self;
	char* handle;
	char* session_handle;
	gchar* app_id;
	GHashTable* options;
	guint response;
	GHashTable* results;
	Block6Data* _data6_;
	ScreenCastSession* session;
	ScreenCastSession* _tmp0_;
	Block7Data* _data7_;
	GDBusConnection* _tmp1_;
	ScreenCastSession* _tmp2_;
	guint _tmp3_;
	GHashTable* _tmp4_;
	gchar* _tmp5_;
	ScreenCastSession* _tmp6_;
	ScreenCastSession* _tmp7_;
	ScreenCastSession* _tmp8_;
	GError* e;
	GError* _tmp9_;
	const gchar* _tmp10_;
	GError* _tmp11_;
	const gchar* _tmp12_;
	GError* _tmp13_;
	ScreenCastSession* _tmp14_;
	GError* _tmp15_;
	GHashFunc _tmp16_;
	GEqualFunc _tmp17_;
	GHashTable* _tmp18_;
	GHashTable* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	GVariant* _tmp23_;
	GError* _inner_error0_;
};

struct _ScreenCastPortalSelectSourcesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ScreenCastPortal* self;
	char* handle;
	char* session_handle;
	gchar* app_id;
	GHashTable* options;
	guint response;
	GHashTable* results;
	ScreenCastSourceType source_types;
	gconstpointer _tmp0_;
	ScreenCastSourceType _tmp1_;
	gboolean multiple;
	gconstpointer _tmp2_;
	gboolean _tmp3_;
	GHashTable* _tmp4_;
	gconstpointer _tmp5_;
	GHashFunc _tmp6_;
	GEqualFunc _tmp7_;
	GHashTable* _tmp8_;
};

struct _ScreenCastSessionPipeWireStream {
	guint node_id;
	GHashTable* properties;
};

struct _Block8Data {
	int _ref_count_;
	ScreenCastPortal* self;
	guint _response;
	ScreenCastSessionPipeWireStream* streams;
	gint streams_length1;
	gint _streams_size_;
	gpointer _async_data_;
};

struct _ScreenCastPortalStartData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ScreenCastPortal* self;
	char* handle;
	char* session_handle;
	gchar* app_id;
	gchar* parent_window;
	GHashTable* options;
	guint response;
	GHashTable* results;
	Block8Data* _data8_;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	ScreenCastSession* session;
	GHashTable* _tmp3_;
	gconstpointer _tmp4_;
	ScreenCastSession* _tmp5_;
	ScreenCastSessionPipeWireStream* _tmp6_;
	ScreenCastSession* _tmp7_;
	ScreenCastSession* _tmp8_;
	GError* _tmp9_;
	GHashTable* _tmp10_;
	gchar* _tmp11_;
	ScreenCastSessionPipeWireStream* _tmp12_;
	gint _tmp12__length1;
	GVariant* _tmp21_;
	GError* _inner_error0_;
};

struct _ScreenCastPortalCreateSessionReadyData {
	GDBusMethodInvocation* _invocation_;
	char* handle;
	char* session_handle;
	gchar* app_id;
	GHashTable* options;
};

struct _ScreenCastPortalSelectSourcesReadyData {
	GDBusMethodInvocation* _invocation_;
	char* handle;
	char* session_handle;
	gchar* app_id;
	GHashTable* options;
};

struct _ScreenCastPortalStartReadyData {
	GDBusMethodInvocation* _invocation_;
	char* handle;
	char* session_handle;
	gchar* app_id;
	gchar* parent_window;
	GHashTable* options;
};

static gint ScreenCastPortal_private_offset;
static gpointer screen_cast_portal_parent_class = NULL;

VALA_EXTERN GType screen_cast_source_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType screen_cast_cursor_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType screen_cast_portal_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ScreenCastPortal, g_object_unref)
VALA_EXTERN guint screen_cast_portal_register_object (void* object,
                                          GDBusConnection* connection,
                                          const gchar* path,
                                          GError** error);
VALA_EXTERN GType screen_cast_session_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ScreenCastSession, g_object_unref)
VALA_EXTERN guint screen_cast_session_register_object (void* object,
                                           GDBusConnection* connection,
                                           const gchar* path,
                                           GError** error);
VALA_EXTERN ScreenCastPortal* screen_cast_portal_new (GDBusConnection* connection);
VALA_EXTERN ScreenCastPortal* screen_cast_portal_construct (GType object_type,
                                                GDBusConnection* connection);
static void _g_free0_ (gpointer var);
static void _g_object_unref0_ (gpointer var);
static void screen_cast_portal_create_session_data_free (gpointer _data);
VALA_EXTERN void screen_cast_portal_create_session (ScreenCastPortal* self,
                                        const char* handle,
                                        const char* session_handle,
                                        const gchar* app_id,
                                        GHashTable* options,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
VALA_EXTERN void screen_cast_portal_create_session_finish (ScreenCastPortal* self,
                                               GAsyncResult* _res_,
                                               guint* response,
                                               GHashTable** results,
                                               GError** error);
static gboolean screen_cast_portal_create_session_co (ScreenCastPortalCreateSessionData* _data_);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
VALA_EXTERN ScreenCastSession* screen_cast_session_new (void);
VALA_EXTERN ScreenCastSession* screen_cast_session_construct (GType object_type);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void ___lambda21_ (Block7Data* _data7_);
static void ____lambda21__screen_cast_session_closed (ScreenCastSession* _sender,
                                               GHashTable* details,
                                               gpointer self);
VALA_EXTERN void screen_cast_session_init (ScreenCastSession* self,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_);
VALA_EXTERN gboolean screen_cast_session_init_finish (ScreenCastSession* self,
                                          GAsyncResult* _res_);
static void screen_cast_portal_create_session_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_);
static void _g_variant_unref0_ (gpointer var);
static GVariant* _variant_new9 (gchar* value);
static void screen_cast_portal_select_sources_data_free (gpointer _data);
VALA_EXTERN void screen_cast_portal_select_sources (ScreenCastPortal* self,
                                        const char* handle,
                                        const char* session_handle,
                                        const gchar* app_id,
                                        GHashTable* options,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
VALA_EXTERN void screen_cast_portal_select_sources_finish (ScreenCastPortal* self,
                                               GAsyncResult* _res_,
                                               guint* response,
                                               GHashTable** results,
                                               GError** error);
static gboolean screen_cast_portal_select_sources_co (ScreenCastPortalSelectSourcesData* _data_);
static ScreenCastSourceType _variant_get5 (GVariant* value);
static gboolean _variant_get6 (GVariant* value);
VALA_EXTERN void screen_cast_session_select_sources (ScreenCastSession* self,
                                         ScreenCastSourceType source_types,
                                         gboolean allow_multiple);
static void screen_cast_portal_start_data_free (gpointer _data);
VALA_EXTERN void screen_cast_portal_start (ScreenCastPortal* self,
                               const char* handle,
                               const char* session_handle,
                               const gchar* app_id,
                               const gchar* parent_window,
                               GHashTable* options,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_);
VALA_EXTERN void screen_cast_portal_start_finish (ScreenCastPortal* self,
                                      GAsyncResult* _res_,
                                      guint* response,
                                      GHashTable** results,
                                      GError** error);
static gboolean screen_cast_portal_start_co (ScreenCastPortalStartData* _data_);
VALA_EXTERN GType screen_cast_session_pipe_wire_stream_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ScreenCastSessionPipeWireStream* screen_cast_session_pipe_wire_stream_dup (const ScreenCastSessionPipeWireStream* self);
VALA_EXTERN void screen_cast_session_pipe_wire_stream_free (ScreenCastSessionPipeWireStream* self);
VALA_EXTERN void screen_cast_session_pipe_wire_stream_copy (const ScreenCastSessionPipeWireStream* self,
                                                ScreenCastSessionPipeWireStream* dest);
VALA_EXTERN void screen_cast_session_pipe_wire_stream_destroy (ScreenCastSessionPipeWireStream* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (ScreenCastSessionPipeWireStream, screen_cast_session_pipe_wire_stream_destroy)
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void _vala_ScreenCastSessionPipeWireStream_array_free (ScreenCastSessionPipeWireStream * array,
                                                       gssize array_length);
static void block8_data_unref (void * _userdata_);
static void __lambda22_ (Block8Data* _data8_,
                  guint session_response,
                  ScreenCastSessionPipeWireStream* session_streams,
                  gint session_streams_length1);
static ScreenCastSessionPipeWireStream* _vala_array_dup10 (ScreenCastSessionPipeWireStream* self,
                                                    gssize length);
static void ___lambda22__screen_cast_session_started (ScreenCastSession* _sender,
                                               guint response,
                                               ScreenCastSessionPipeWireStream* streams,
                                               gint streams_length1,
                                               gpointer self);
VALA_EXTERN void screen_cast_session_start (ScreenCastSession* self,
                                const gchar* parent_window);
static GVariant* _variant_new10 (ScreenCastSessionPipeWireStream* value,
                          gint value_length1);
VALA_EXTERN ScreenCastSourceType screen_cast_portal_get_available_source_types (ScreenCastPortal* self);
VALA_EXTERN ScreenCastCursorMode screen_cast_portal_get_available_cursor_modes (ScreenCastPortal* self);
VALA_EXTERN guint screen_cast_portal_get_version (ScreenCastPortal* self);
static void screen_cast_portal_finalize (GObject * obj);
static GType screen_cast_portal_get_type_once (void);
static void _vala_screen_cast_portal_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _dbus_screen_cast_portal_create_session (ScreenCastPortal* self,
                                              GVariant* _parameters_,
                                              GDBusMethodInvocation* invocation);
static void _dbus_screen_cast_portal_create_session_ready (GObject * source_object,
                                                    GAsyncResult * _res_,
                                                    gpointer _user_data_);
static void _dbus_screen_cast_portal_select_sources (ScreenCastPortal* self,
                                              GVariant* _parameters_,
                                              GDBusMethodInvocation* invocation);
static void _dbus_screen_cast_portal_select_sources_ready (GObject * source_object,
                                                    GAsyncResult * _res_,
                                                    gpointer _user_data_);
static void _dbus_screen_cast_portal_start (ScreenCastPortal* self,
                                     GVariant* _parameters_,
                                     GDBusMethodInvocation* invocation);
static void _dbus_screen_cast_portal_start_ready (GObject * source_object,
                                           GAsyncResult * _res_,
                                           gpointer _user_data_);
static void screen_cast_portal_dbus_interface_method_call (GDBusConnection* connection,
                                                    const gchar* sender,
                                                    const gchar* object_path,
                                                    const gchar* interface_name,
                                                    const gchar* method_name,
                                                    GVariant* parameters,
                                                    GDBusMethodInvocation* invocation,
                                                    gpointer user_data);
static GVariant* screen_cast_portal_dbus_interface_get_property (GDBusConnection* connection,
                                                          const gchar* sender,
                                                          const gchar* object_path,
                                                          const gchar* interface_name,
                                                          const gchar* property_name,
                                                          GError** error,
                                                          gpointer user_data);
static GVariant* _dbus_screen_cast_portal_get_available_source_types (ScreenCastPortal* self);
static GVariant* _dbus_screen_cast_portal_get_available_cursor_modes (ScreenCastPortal* self);
static GVariant* _dbus_screen_cast_portal_get_version (ScreenCastPortal* self);
static gboolean screen_cast_portal_dbus_interface_set_property (GDBusConnection* connection,
                                                         const gchar* sender,
                                                         const gchar* object_path,
                                                         const gchar* interface_name,
                                                         const gchar* property_name,
                                                         GVariant* value,
                                                         GError** error,
                                                         gpointer user_data);
static void _screen_cast_portal_unregister_object (gpointer user_data);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const GDBusArgInfo _screen_cast_portal_dbus_arg_info_create_session_handle = {-1, "handle", "o", NULL};
static const GDBusArgInfo _screen_cast_portal_dbus_arg_info_create_session_session_handle = {-1, "session_handle", "o", NULL};
static const GDBusArgInfo _screen_cast_portal_dbus_arg_info_create_session_app_id = {-1, "app_id", "s", NULL};
static const GDBusArgInfo _screen_cast_portal_dbus_arg_info_create_session_options = {-1, "options", "a{sv}", NULL};
static const GDBusArgInfo _screen_cast_portal_dbus_arg_info_create_session_response = {-1, "response", "u", NULL};
static const GDBusArgInfo _screen_cast_portal_dbus_arg_info_create_session_results = {-1, "results", "a{sv}", NULL};
static const GDBusArgInfo * const _screen_cast_portal_dbus_arg_info_create_session_in[] = {&_screen_cast_portal_dbus_arg_info_create_session_handle, &_screen_cast_portal_dbus_arg_info_create_session_session_handle, &_screen_cast_portal_dbus_arg_info_create_session_app_id, &_screen_cast_portal_dbus_arg_info_create_session_options, NULL};
static const GDBusArgInfo * const _screen_cast_portal_dbus_arg_info_create_session_out[] = {&_screen_cast_portal_dbus_arg_info_create_session_response, &_screen_cast_portal_dbus_arg_info_create_session_results, NULL};
static const GDBusMethodInfo _screen_cast_portal_dbus_method_info_create_session = {-1, "CreateSession", (GDBusArgInfo **) (&_screen_cast_portal_dbus_arg_info_create_session_in), (GDBusArgInfo **) (&_screen_cast_portal_dbus_arg_info_create_session_out), NULL};
static const GDBusArgInfo _screen_cast_portal_dbus_arg_info_select_sources_handle = {-1, "handle", "o", NULL};
static const GDBusArgInfo _screen_cast_portal_dbus_arg_info_select_sources_session_handle = {-1, "session_handle", "o", NULL};
static const GDBusArgInfo _screen_cast_portal_dbus_arg_info_select_sources_app_id = {-1, "app_id", "s", NULL};
static const GDBusArgInfo _screen_cast_portal_dbus_arg_info_select_sources_options = {-1, "options", "a{sv}", NULL};
static const GDBusArgInfo _screen_cast_portal_dbus_arg_info_select_sources_response = {-1, "response", "u", NULL};
static const GDBusArgInfo _screen_cast_portal_dbus_arg_info_select_sources_results = {-1, "results", "a{sv}", NULL};
static const GDBusArgInfo * const _screen_cast_portal_dbus_arg_info_select_sources_in[] = {&_screen_cast_portal_dbus_arg_info_select_sources_handle, &_screen_cast_portal_dbus_arg_info_select_sources_session_handle, &_screen_cast_portal_dbus_arg_info_select_sources_app_id, &_screen_cast_portal_dbus_arg_info_select_sources_options, NULL};
static const GDBusArgInfo * const _screen_cast_portal_dbus_arg_info_select_sources_out[] = {&_screen_cast_portal_dbus_arg_info_select_sources_response, &_screen_cast_portal_dbus_arg_info_select_sources_results, NULL};
static const GDBusMethodInfo _screen_cast_portal_dbus_method_info_select_sources = {-1, "SelectSources", (GDBusArgInfo **) (&_screen_cast_portal_dbus_arg_info_select_sources_in), (GDBusArgInfo **) (&_screen_cast_portal_dbus_arg_info_select_sources_out), NULL};
static const GDBusArgInfo _screen_cast_portal_dbus_arg_info_start_handle = {-1, "handle", "o", NULL};
static const GDBusArgInfo _screen_cast_portal_dbus_arg_info_start_session_handle = {-1, "session_handle", "o", NULL};
static const GDBusArgInfo _screen_cast_portal_dbus_arg_info_start_app_id = {-1, "app_id", "s", NULL};
static const GDBusArgInfo _screen_cast_portal_dbus_arg_info_start_parent_window = {-1, "parent_window", "s", NULL};
static const GDBusArgInfo _screen_cast_portal_dbus_arg_info_start_options = {-1, "options", "a{sv}", NULL};
static const GDBusArgInfo _screen_cast_portal_dbus_arg_info_start_response = {-1, "response", "u", NULL};
static const GDBusArgInfo _screen_cast_portal_dbus_arg_info_start_results = {-1, "results", "a{sv}", NULL};
static const GDBusArgInfo * const _screen_cast_portal_dbus_arg_info_start_in[] = {&_screen_cast_portal_dbus_arg_info_start_handle, &_screen_cast_portal_dbus_arg_info_start_session_handle, &_screen_cast_portal_dbus_arg_info_start_app_id, &_screen_cast_portal_dbus_arg_info_start_parent_window, &_screen_cast_portal_dbus_arg_info_start_options, NULL};
static const GDBusArgInfo * const _screen_cast_portal_dbus_arg_info_start_out[] = {&_screen_cast_portal_dbus_arg_info_start_response, &_screen_cast_portal_dbus_arg_info_start_results, NULL};
static const GDBusMethodInfo _screen_cast_portal_dbus_method_info_start = {-1, "Start", (GDBusArgInfo **) (&_screen_cast_portal_dbus_arg_info_start_in), (GDBusArgInfo **) (&_screen_cast_portal_dbus_arg_info_start_out), NULL};
static const GDBusMethodInfo * const _screen_cast_portal_dbus_method_info[] = {&_screen_cast_portal_dbus_method_info_create_session, &_screen_cast_portal_dbus_method_info_select_sources, &_screen_cast_portal_dbus_method_info_start, NULL};
static const GDBusSignalInfo * const _screen_cast_portal_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo _screen_cast_portal_dbus_property_info_available_source_types = {-1, "AvailableSourceTypes", "u", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _screen_cast_portal_dbus_property_info_available_cursor_modes = {-1, "AvailableCursorModes", "u", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _screen_cast_portal_dbus_property_info_version = {-1, "Version", "u", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo * const _screen_cast_portal_dbus_property_info[] = {&_screen_cast_portal_dbus_property_info_available_source_types, &_screen_cast_portal_dbus_property_info_available_cursor_modes, &_screen_cast_portal_dbus_property_info_version, NULL};
static const GDBusInterfaceInfo _screen_cast_portal_dbus_interface_info = {-1, "org.freedesktop.impl.portal.ScreenCast", (GDBusMethodInfo **) (&_screen_cast_portal_dbus_method_info), (GDBusSignalInfo **) (&_screen_cast_portal_dbus_signal_info), (GDBusPropertyInfo **) (&_screen_cast_portal_dbus_property_info), NULL};
static const GDBusInterfaceVTable _screen_cast_portal_dbus_interface_vtable = {screen_cast_portal_dbus_interface_method_call, screen_cast_portal_dbus_interface_get_property, screen_cast_portal_dbus_interface_set_property};

static GType
screen_cast_source_type_get_type_once (void)
{
	static const GFlagsValue values[] = {{SCREEN_CAST_SOURCE_TYPE_MONITOR, "SCREEN_CAST_SOURCE_TYPE_MONITOR", "monitor"}, {SCREEN_CAST_SOURCE_TYPE_WINDOW, "SCREEN_CAST_SOURCE_TYPE_WINDOW", "window"}, {SCREEN_CAST_SOURCE_TYPE_VIRTUAL, "SCREEN_CAST_SOURCE_TYPE_VIRTUAL", "virtual"}, {0, NULL, NULL}};
	GType screen_cast_source_type_type_id;
	screen_cast_source_type_type_id = g_flags_register_static ("ScreenCastSourceType", values);
	return screen_cast_source_type_type_id;
}

GType
screen_cast_source_type_get_type (void)
{
	static volatile gsize screen_cast_source_type_type_id__once = 0;
	if (g_once_init_enter (&screen_cast_source_type_type_id__once)) {
		GType screen_cast_source_type_type_id;
		screen_cast_source_type_type_id = screen_cast_source_type_get_type_once ();
		g_once_init_leave (&screen_cast_source_type_type_id__once, screen_cast_source_type_type_id);
	}
	return screen_cast_source_type_type_id__once;
}

static GType
screen_cast_cursor_mode_get_type_once (void)
{
	static const GFlagsValue values[] = {{SCREEN_CAST_CURSOR_MODE_HIDDEN, "SCREEN_CAST_CURSOR_MODE_HIDDEN", "hidden"}, {SCREEN_CAST_CURSOR_MODE_EMBEDDED, "SCREEN_CAST_CURSOR_MODE_EMBEDDED", "embedded"}, {SCREEN_CAST_CURSOR_MODE_METADATA, "SCREEN_CAST_CURSOR_MODE_METADATA", "metadata"}, {0, NULL, NULL}};
	GType screen_cast_cursor_mode_type_id;
	screen_cast_cursor_mode_type_id = g_flags_register_static ("ScreenCastCursorMode", values);
	return screen_cast_cursor_mode_type_id;
}

GType
screen_cast_cursor_mode_get_type (void)
{
	static volatile gsize screen_cast_cursor_mode_type_id__once = 0;
	if (g_once_init_enter (&screen_cast_cursor_mode_type_id__once)) {
		GType screen_cast_cursor_mode_type_id;
		screen_cast_cursor_mode_type_id = screen_cast_cursor_mode_get_type_once ();
		g_once_init_leave (&screen_cast_cursor_mode_type_id__once, screen_cast_cursor_mode_type_id);
	}
	return screen_cast_cursor_mode_type_id__once;
}

static inline gpointer
screen_cast_portal_get_instance_private (ScreenCastPortal* self)
{
	return G_STRUCT_MEMBER_P (self, ScreenCastPortal_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

ScreenCastPortal*
screen_cast_portal_construct (GType object_type,
                              GDBusConnection* connection)
{
	ScreenCastPortal * self = NULL;
	GDBusConnection* _tmp0_;
	GHashFunc _tmp1_;
	GEqualFunc _tmp2_;
	GHashTable* _tmp3_;
	g_return_val_if_fail (connection != NULL, NULL);
	self = (ScreenCastPortal*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (connection);
	_g_object_unref0 (self->priv->connection);
	self->priv->connection = _tmp0_;
	_tmp1_ = g_str_hash;
	_tmp2_ = g_str_equal;
	_tmp3_ = g_hash_table_new_full (_tmp1_, _tmp2_, _g_free0_, _g_object_unref0_);
	_g_hash_table_unref0 (self->priv->sessions);
	self->priv->sessions = _tmp3_;
	return self;
}

ScreenCastPortal*
screen_cast_portal_new (GDBusConnection* connection)
{
	return screen_cast_portal_construct (SCREEN_CAST_TYPE_PORTAL, connection);
}

static void
screen_cast_portal_create_session_data_free (gpointer _data)
{
	ScreenCastPortalCreateSessionData* _data_;
	_data_ = _data;
	_g_free0 (_data_->handle);
	_g_free0 (_data_->app_id);
	_g_hash_table_unref0 (_data_->options);
	_g_object_unref0 (_data_->self);
	g_slice_free (ScreenCastPortalCreateSessionData, _data_);
}

static gpointer
_g_hash_table_ref0 (gpointer self)
{
	return self ? g_hash_table_ref (self) : NULL;
}

void
screen_cast_portal_create_session (ScreenCastPortal* self,
                                   const char* handle,
                                   const char* session_handle,
                                   const gchar* app_id,
                                   GHashTable* options,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	ScreenCastPortalCreateSessionData* _data_;
	ScreenCastPortal* _tmp0_;
	char* _tmp1_;
	char* _tmp2_;
	gchar* _tmp3_;
	GHashTable* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (handle != NULL);
	g_return_if_fail (session_handle != NULL);
	g_return_if_fail (app_id != NULL);
	g_return_if_fail (options != NULL);
	_data_ = g_slice_new0 (ScreenCastPortalCreateSessionData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, screen_cast_portal_create_session_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = g_strdup (handle);
	_g_free0 (_data_->handle);
	_data_->handle = _tmp1_;
	_tmp2_ = g_strdup (session_handle);
	_g_free0 (_data_->session_handle);
	_data_->session_handle = _tmp2_;
	_tmp3_ = g_strdup (app_id);
	_g_free0 (_data_->app_id);
	_data_->app_id = _tmp3_;
	_tmp4_ = _g_hash_table_ref0 (options);
	_g_hash_table_unref0 (_data_->options);
	_data_->options = _tmp4_;
	screen_cast_portal_create_session_co (_data_);
}

void
screen_cast_portal_create_session_finish (ScreenCastPortal* self,
                                          GAsyncResult* _res_,
                                          guint* response,
                                          GHashTable** results,
                                          GError** error)
{
	ScreenCastPortalCreateSessionData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return;
	}
	if (response) {
		*response = _data_->response;
	}
	if (results) {
		*results = _data_->results;
	} else {
		_g_hash_table_unref0 (_data_->results);
	}
	_data_->results = NULL;
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
	g_atomic_int_inc (&_data6_->_ref_count_);
	return _data6_;
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
		ScreenCastPortal* self;
		self = _data6_->self;
		_g_free0 (_data6_->session_handle);
		_g_object_unref0 (self);
		g_slice_free (Block6Data, _data6_);
	}
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
	g_atomic_int_inc (&_data7_->_ref_count_);
	return _data7_;
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
		ScreenCastPortal* self;
		self = _data7_->_data6_->self;
		block6_data_unref (_data7_->_data6_);
		_data7_->_data6_ = NULL;
		g_slice_free (Block7Data, _data7_);
	}
}

static void
___lambda21_ (Block7Data* _data7_)
{
	Block6Data* _data6_;
	ScreenCastPortal* self;
	GDBusConnection* _tmp0_;
	GHashTable* _tmp1_;
	_data6_ = _data7_->_data6_;
	self = _data6_->self;
	_tmp0_ = self->priv->connection;
	g_dbus_connection_unregister_object (_tmp0_, _data7_->session_register_id);
	_tmp1_ = self->priv->sessions;
	g_hash_table_remove (_tmp1_, (const gchar*) _data6_->session_handle);
}

static void
____lambda21__screen_cast_session_closed (ScreenCastSession* _sender,
                                          GHashTable* details,
                                          gpointer self)
{
	___lambda21_ (self);
}

static void
screen_cast_portal_create_session_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_)
{
	ScreenCastPortalCreateSessionData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	screen_cast_portal_create_session_co (_data_);
}

static void
_g_variant_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_variant_unref (var), NULL));
}

static GVariant*
_variant_new9 (gchar* value)
{
	return g_variant_ref_sink (g_variant_new_string (value));
}

static gboolean
screen_cast_portal_create_session_co (ScreenCastPortalCreateSessionData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data6_ = g_slice_new0 (Block6Data);
	_data_->_data6_->_ref_count_ = 1;
	_data_->_data6_->self = g_object_ref (_data_->self);
	_g_free0 (_data_->_data6_->session_handle);
	_data_->_data6_->session_handle = _data_->session_handle;
	_data_->_data6_->_async_data_ = _data_;
	_data_->_tmp0_ = screen_cast_session_new ();
	_data_->session = _data_->_tmp0_;
	{
		_data_->_data7_ = g_slice_new0 (Block7Data);
		_data_->_data7_->_ref_count_ = 1;
		_data_->_data7_->_data6_ = block6_data_ref (_data_->_data6_);
		_data_->_tmp1_ = _data_->self->priv->connection;
		_data_->_tmp2_ = _data_->session;
		_data_->_tmp3_ = screen_cast_session_register_object (_data_->_tmp2_, _data_->_tmp1_, (const gchar*) _data_->_data6_->session_handle, &_data_->_inner_error0_);
		_data_->_data7_->session_register_id = _data_->_tmp3_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			block7_data_unref (_data_->_data7_);
			_data_->_data7_ = NULL;
			goto __catch0_g_error;
		}
		_data_->_tmp4_ = _data_->self->priv->sessions;
		_data_->_tmp5_ = g_strdup ((gchar*) _data_->_data6_->session_handle);
		_data_->_tmp6_ = _data_->session;
		_data_->_tmp7_ = _g_object_ref0 (_data_->_tmp6_);
		g_hash_table_insert (_data_->_tmp4_, _data_->_tmp5_, _data_->_tmp7_);
		_data_->_tmp8_ = _data_->session;
		g_signal_connect_data (_data_->_tmp8_, "closed", (GCallback) ____lambda21__screen_cast_session_closed, block7_data_ref (_data_->_data7_), (GClosureNotify) block7_data_unref, 0);
		block7_data_unref (_data_->_data7_);
		_data_->_data7_ = NULL;
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp9_ = _data_->e;
		_data_->_tmp10_ = _data_->_tmp9_->message;
		g_warning ("Portal.vala:54: Failed to export session object: %s", _data_->_tmp10_);
		_data_->_tmp11_ = _data_->e;
		_data_->_tmp12_ = _data_->_tmp11_->message;
		_data_->_tmp13_ = g_error_new_literal (G_DBUS_ERROR, G_DBUS_ERROR_OBJECT_PATH_IN_USE, _data_->_tmp12_);
		_data_->_inner_error0_ = _data_->_tmp13_;
		_g_error_free0 (_data_->e);
		goto __finally0;
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		if ((_data_->_inner_error0_->domain == G_DBUS_ERROR) || (_data_->_inner_error0_->domain == G_IO_ERROR)) {
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
			_g_object_unref0 (_data_->session);
			block6_data_unref (_data_->_data6_);
			_data_->_data6_ = NULL;
			_g_hash_table_unref0 (_data_->results);
			g_object_unref (_data_->_async_result);
			return FALSE;
		} else {
			_g_object_unref0 (_data_->session);
			block6_data_unref (_data_->_data6_);
			_data_->_data6_ = NULL;
			_g_hash_table_unref0 (_data_->results);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
	}
	_data_->_tmp14_ = _data_->session;
	_data_->_state_ = 1;
	screen_cast_session_init (_data_->_tmp14_, screen_cast_portal_create_session_ready, _data_);
	return FALSE;
	_state_1:
	if (!screen_cast_session_init_finish (_data_->_tmp14_, _data_->_res_)) {
		_data_->_tmp15_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_FAILED, "Failed to create mutter ScreenCast session.");
		_data_->_inner_error0_ = _data_->_tmp15_;
		if ((_data_->_inner_error0_->domain == G_DBUS_ERROR) || (_data_->_inner_error0_->domain == G_IO_ERROR)) {
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
			_g_object_unref0 (_data_->session);
			block6_data_unref (_data_->_data6_);
			_data_->_data6_ = NULL;
			_g_hash_table_unref0 (_data_->results);
			g_object_unref (_data_->_async_result);
			return FALSE;
		} else {
			_g_object_unref0 (_data_->session);
			block6_data_unref (_data_->_data6_);
			_data_->_data6_ = NULL;
			_g_hash_table_unref0 (_data_->results);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
	}
	_data_->response = (guint) 0;
	_data_->_tmp16_ = g_str_hash;
	_data_->_tmp17_ = g_str_equal;
	_data_->_tmp18_ = g_hash_table_new_full (_data_->_tmp16_, _data_->_tmp17_, _g_free0_, _g_variant_unref0_);
	_g_hash_table_unref0 (_data_->results);
	_data_->results = _data_->_tmp18_;
	_data_->_tmp19_ = _data_->results;
	_data_->_tmp20_ = g_strdup ("session_id");
	_data_->_tmp21_ = g_uuid_string_random ();
	_data_->_tmp22_ = _data_->_tmp21_;
	_data_->_tmp23_ = _variant_new9 (_data_->_tmp22_);
	g_hash_table_insert (_data_->_tmp19_, _data_->_tmp20_, _data_->_tmp23_);
	_g_free0 (_data_->_tmp22_);
	_g_object_unref0 (_data_->session);
	block6_data_unref (_data_->_data6_);
	_data_->_data6_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
screen_cast_portal_select_sources_data_free (gpointer _data)
{
	ScreenCastPortalSelectSourcesData* _data_;
	_data_ = _data;
	_g_free0 (_data_->handle);
	_g_free0 (_data_->session_handle);
	_g_free0 (_data_->app_id);
	_g_hash_table_unref0 (_data_->options);
	_g_object_unref0 (_data_->self);
	g_slice_free (ScreenCastPortalSelectSourcesData, _data_);
}

void
screen_cast_portal_select_sources (ScreenCastPortal* self,
                                   const char* handle,
                                   const char* session_handle,
                                   const gchar* app_id,
                                   GHashTable* options,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	ScreenCastPortalSelectSourcesData* _data_;
	ScreenCastPortal* _tmp0_;
	char* _tmp1_;
	char* _tmp2_;
	gchar* _tmp3_;
	GHashTable* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (handle != NULL);
	g_return_if_fail (session_handle != NULL);
	g_return_if_fail (app_id != NULL);
	g_return_if_fail (options != NULL);
	_data_ = g_slice_new0 (ScreenCastPortalSelectSourcesData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, screen_cast_portal_select_sources_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = g_strdup (handle);
	_g_free0 (_data_->handle);
	_data_->handle = _tmp1_;
	_tmp2_ = g_strdup (session_handle);
	_g_free0 (_data_->session_handle);
	_data_->session_handle = _tmp2_;
	_tmp3_ = g_strdup (app_id);
	_g_free0 (_data_->app_id);
	_data_->app_id = _tmp3_;
	_tmp4_ = _g_hash_table_ref0 (options);
	_g_hash_table_unref0 (_data_->options);
	_data_->options = _tmp4_;
	screen_cast_portal_select_sources_co (_data_);
}

void
screen_cast_portal_select_sources_finish (ScreenCastPortal* self,
                                          GAsyncResult* _res_,
                                          guint* response,
                                          GHashTable** results,
                                          GError** error)
{
	ScreenCastPortalSelectSourcesData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return;
	}
	if (response) {
		*response = _data_->response;
	}
	if (results) {
		*results = _data_->results;
	} else {
		_g_hash_table_unref0 (_data_->results);
	}
	_data_->results = NULL;
}

static ScreenCastSourceType
_variant_get5 (GVariant* value)
{
	return g_variant_get_uint32 (value);
}

static gboolean
_variant_get6 (GVariant* value)
{
	return g_variant_get_boolean (value);
}

static gboolean
screen_cast_portal_select_sources_co (ScreenCastPortalSelectSourcesData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->source_types = SCREEN_CAST_SOURCE_TYPE_MONITOR;
	if (g_hash_table_contains (_data_->options, "types")) {
		_data_->_tmp0_ = g_hash_table_lookup (_data_->options, "types");
		_data_->_tmp1_ = _variant_get5 ((GVariant*) _data_->_tmp0_);
		_data_->source_types = _data_->_tmp1_;
	}
	_data_->multiple = FALSE;
	if (g_hash_table_contains (_data_->options, "multiple")) {
		_data_->_tmp2_ = g_hash_table_lookup (_data_->options, "multiple");
		_data_->_tmp3_ = _variant_get6 ((GVariant*) _data_->_tmp2_);
		_data_->multiple = _data_->_tmp3_;
	}
	_data_->_tmp4_ = _data_->self->priv->sessions;
	_data_->_tmp5_ = g_hash_table_lookup (_data_->_tmp4_, (const gchar*) _data_->session_handle);
	screen_cast_session_select_sources ((ScreenCastSession*) _data_->_tmp5_, _data_->source_types, _data_->multiple);
	_data_->response = (guint) 0;
	_data_->_tmp6_ = g_str_hash;
	_data_->_tmp7_ = g_str_equal;
	_data_->_tmp8_ = g_hash_table_new_full (_data_->_tmp6_, _data_->_tmp7_, _g_free0_, _g_variant_unref0_);
	_g_hash_table_unref0 (_data_->results);
	_data_->results = _data_->_tmp8_;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
screen_cast_portal_start_data_free (gpointer _data)
{
	ScreenCastPortalStartData* _data_;
	_data_ = _data;
	_g_free0 (_data_->handle);
	_g_free0 (_data_->session_handle);
	_g_free0 (_data_->app_id);
	_g_free0 (_data_->parent_window);
	_g_hash_table_unref0 (_data_->options);
	_g_object_unref0 (_data_->self);
	g_slice_free (ScreenCastPortalStartData, _data_);
}

void
screen_cast_portal_start (ScreenCastPortal* self,
                          const char* handle,
                          const char* session_handle,
                          const gchar* app_id,
                          const gchar* parent_window,
                          GHashTable* options,
                          GAsyncReadyCallback _callback_,
                          gpointer _user_data_)
{
	ScreenCastPortalStartData* _data_;
	ScreenCastPortal* _tmp0_;
	char* _tmp1_;
	char* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GHashTable* _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (handle != NULL);
	g_return_if_fail (session_handle != NULL);
	g_return_if_fail (app_id != NULL);
	g_return_if_fail (parent_window != NULL);
	g_return_if_fail (options != NULL);
	_data_ = g_slice_new0 (ScreenCastPortalStartData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, screen_cast_portal_start_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = g_strdup (handle);
	_g_free0 (_data_->handle);
	_data_->handle = _tmp1_;
	_tmp2_ = g_strdup (session_handle);
	_g_free0 (_data_->session_handle);
	_data_->session_handle = _tmp2_;
	_tmp3_ = g_strdup (app_id);
	_g_free0 (_data_->app_id);
	_data_->app_id = _tmp3_;
	_tmp4_ = g_strdup (parent_window);
	_g_free0 (_data_->parent_window);
	_data_->parent_window = _tmp4_;
	_tmp5_ = _g_hash_table_ref0 (options);
	_g_hash_table_unref0 (_data_->options);
	_data_->options = _tmp5_;
	screen_cast_portal_start_co (_data_);
}

void
screen_cast_portal_start_finish (ScreenCastPortal* self,
                                 GAsyncResult* _res_,
                                 guint* response,
                                 GHashTable** results,
                                 GError** error)
{
	ScreenCastPortalStartData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return;
	}
	if (response) {
		*response = _data_->response;
	}
	if (results) {
		*results = _data_->results;
	} else {
		_g_hash_table_unref0 (_data_->results);
	}
	_data_->results = NULL;
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
	g_atomic_int_inc (&_data8_->_ref_count_);
	return _data8_;
}

static void
_vala_ScreenCastSessionPipeWireStream_array_free (ScreenCastSessionPipeWireStream * array,
                                                  gssize array_length)
{
	if (array != NULL) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			screen_cast_session_pipe_wire_stream_destroy (&array[i]);
		}
	}
	g_free (array);
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
		ScreenCastPortal* self;
		self = _data8_->self;
		_data8_->streams = (_vala_ScreenCastSessionPipeWireStream_array_free (_data8_->streams, _data8_->streams_length1), NULL);
		_g_object_unref0 (self);
		g_slice_free (Block8Data, _data8_);
	}
}

static ScreenCastSessionPipeWireStream*
_vala_array_dup10 (ScreenCastSessionPipeWireStream* self,
                   gssize length)
{
	if (length > 0) {
		ScreenCastSessionPipeWireStream* result;
		gssize i;
		result = g_new0 (ScreenCastSessionPipeWireStream, length);
		for (i = 0; i < length; i++) {
			ScreenCastSessionPipeWireStream _tmp0_;
			ScreenCastSessionPipeWireStream _tmp1_ = {0};
			_tmp0_ = self[i];
			screen_cast_session_pipe_wire_stream_copy (&_tmp0_, &_tmp1_);
			result[i] = _tmp1_;
		}
		return result;
	}
	return NULL;
}

static void
__lambda22_ (Block8Data* _data8_,
             guint session_response,
             ScreenCastSessionPipeWireStream* session_streams,
             gint session_streams_length1)
{
	ScreenCastPortal* self;
	ScreenCastSessionPipeWireStream* _tmp0_;
	gint _tmp0__length1;
	self = _data8_->self;
	_data8_->_response = session_response;
	_tmp0_ = (session_streams != NULL) ? _vala_array_dup10 (session_streams, session_streams_length1) : session_streams;
	_tmp0__length1 = session_streams_length1;
	_data8_->streams = (_vala_ScreenCastSessionPipeWireStream_array_free (_data8_->streams, _data8_->streams_length1), NULL);
	_data8_->streams = _tmp0_;
	_data8_->streams_length1 = _tmp0__length1;
	_data8_->_streams_size_ = _data8_->streams_length1;
	screen_cast_portal_start_co (_data8_->_async_data_);
}

static void
___lambda22__screen_cast_session_started (ScreenCastSession* _sender,
                                          guint response,
                                          ScreenCastSessionPipeWireStream* streams,
                                          gint streams_length1,
                                          gpointer self)
{
	__lambda22_ (self, response, streams, streams_length1);
}

static GVariant*
_variant_new10 (ScreenCastSessionPipeWireStream* value,
                gint value_length1)
{
	ScreenCastSessionPipeWireStream* _tmp13_;
	GVariantBuilder _tmp14_;
	gint _tmp15_;
	_tmp13_ = value;
	g_variant_builder_init (&_tmp14_, G_VARIANT_TYPE ("a(ua{sv})"));
	for (_tmp15_ = 0; _tmp15_ < value_length1; _tmp15_++) {
		GVariantBuilder _tmp16_;
		GVariantBuilder _tmp17_;
		GHashTableIter _tmp18_;
		gpointer _tmp19_;
		gpointer _tmp20_;
		g_variant_builder_init (&_tmp16_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp16_, g_variant_new_uint32 ((*_tmp13_).node_id));
		g_hash_table_iter_init (&_tmp18_, (*_tmp13_).properties);
		g_variant_builder_init (&_tmp17_, G_VARIANT_TYPE ("a{sv}"));
		while (g_hash_table_iter_next (&_tmp18_, &_tmp19_, &_tmp20_)) {
			gchar* _key;
			GVariant* _value;
			_key = (gchar*) _tmp19_;
			_value = (GVariant*) _tmp20_;
			g_variant_builder_add (&_tmp17_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
		}
		g_variant_builder_add_value (&_tmp16_, g_variant_builder_end (&_tmp17_));
		g_variant_builder_add_value (&_tmp14_, g_variant_builder_end (&_tmp16_));
		_tmp13_++;
	}
	return g_variant_ref_sink (g_variant_builder_end (&_tmp14_));
}

static gboolean
screen_cast_portal_start_co (ScreenCastPortalStartData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data8_ = g_slice_new0 (Block8Data);
	_data_->_data8_->_ref_count_ = 1;
	_data_->_data8_->self = g_object_ref (_data_->self);
	_data_->_data8_->_async_data_ = _data_;
	_data_->_tmp0_ = g_str_hash;
	_data_->_tmp1_ = g_str_equal;
	_data_->_tmp2_ = g_hash_table_new_full (_data_->_tmp0_, _data_->_tmp1_, _g_free0_, _g_variant_unref0_);
	_g_hash_table_unref0 (_data_->results);
	_data_->results = _data_->_tmp2_;
	_data_->_tmp3_ = _data_->self->priv->sessions;
	_data_->_tmp4_ = g_hash_table_lookup (_data_->_tmp3_, (const gchar*) _data_->session_handle);
	_data_->_tmp5_ = _g_object_ref0 ((ScreenCastSession*) _data_->_tmp4_);
	_data_->session = _data_->_tmp5_;
	_data_->_data8_->_response = (guint) 2;
	_data_->_tmp6_ = g_new0 (ScreenCastSessionPipeWireStream, 0);
	_data_->_data8_->streams = _data_->_tmp6_;
	_data_->_data8_->streams_length1 = 0;
	_data_->_data8_->_streams_size_ = _data_->_data8_->streams_length1;
	_data_->_tmp7_ = _data_->session;
	g_signal_connect_data (_data_->_tmp7_, "started", (GCallback) ___lambda22__screen_cast_session_started, block8_data_ref (_data_->_data8_), (GClosureNotify) block8_data_unref, 0);
	_data_->_tmp8_ = _data_->session;
	screen_cast_session_start (_data_->_tmp8_, _data_->parent_window);
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	if (_data_->_data8_->_response == ((guint) 2)) {
		_data_->_tmp9_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_FAILED, "Failed to get pipewire streams");
		_data_->_inner_error0_ = _data_->_tmp9_;
		if ((_data_->_inner_error0_->domain == G_DBUS_ERROR) || (_data_->_inner_error0_->domain == G_IO_ERROR)) {
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
			_g_object_unref0 (_data_->session);
			block8_data_unref (_data_->_data8_);
			_data_->_data8_ = NULL;
			_g_hash_table_unref0 (_data_->results);
			g_object_unref (_data_->_async_result);
			return FALSE;
		} else {
			_g_object_unref0 (_data_->session);
			block8_data_unref (_data_->_data8_);
			_data_->_data8_ = NULL;
			_g_hash_table_unref0 (_data_->results);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
	}
	_data_->response = _data_->_data8_->_response;
	_data_->_tmp10_ = _data_->results;
	_data_->_tmp11_ = g_strdup ("streams");
	_data_->_tmp12_ = _data_->_data8_->streams;
	_data_->_tmp12__length1 = _data_->_data8_->streams_length1;
	_data_->_tmp21_ = _variant_new10 (_data_->_tmp12_, _data_->_tmp12__length1);
	g_hash_table_insert (_data_->_tmp10_, _data_->_tmp11_, _data_->_tmp21_);
	_g_object_unref0 (_data_->session);
	block8_data_unref (_data_->_data8_);
	_data_->_data8_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

ScreenCastSourceType
screen_cast_portal_get_available_source_types (ScreenCastPortal* self)
{
	ScreenCastSourceType result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_available_source_types;
	return result;
}

ScreenCastCursorMode
screen_cast_portal_get_available_cursor_modes (ScreenCastPortal* self)
{
	ScreenCastCursorMode result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_available_cursor_modes;
	return result;
}

guint
screen_cast_portal_get_version (ScreenCastPortal* self)
{
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_version;
	return result;
}

static void
screen_cast_portal_class_init (ScreenCastPortalClass * klass,
                               gpointer klass_data)
{
	screen_cast_portal_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ScreenCastPortal_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_screen_cast_portal_get_property;
	G_OBJECT_CLASS (klass)->finalize = screen_cast_portal_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCREEN_CAST_PORTAL_AVAILABLE_SOURCE_TYPES_PROPERTY, screen_cast_portal_properties[SCREEN_CAST_PORTAL_AVAILABLE_SOURCE_TYPES_PROPERTY] = g_param_spec_flags ("available-source-types", "available-source-types", "available-source-types", SCREEN_CAST_TYPE_SOURCE_TYPE, (SCREEN_CAST_SOURCE_TYPE_MONITOR | SCREEN_CAST_SOURCE_TYPE_WINDOW) | SCREEN_CAST_SOURCE_TYPE_VIRTUAL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCREEN_CAST_PORTAL_AVAILABLE_CURSOR_MODES_PROPERTY, screen_cast_portal_properties[SCREEN_CAST_PORTAL_AVAILABLE_CURSOR_MODES_PROPERTY] = g_param_spec_flags ("available-cursor-modes", "available-cursor-modes", "available-cursor-modes", SCREEN_CAST_TYPE_CURSOR_MODE, (SCREEN_CAST_CURSOR_MODE_HIDDEN | SCREEN_CAST_CURSOR_MODE_EMBEDDED) | SCREEN_CAST_CURSOR_MODE_METADATA, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCREEN_CAST_PORTAL_VERSION_PROPERTY, screen_cast_portal_properties[SCREEN_CAST_PORTAL_VERSION_PROPERTY] = g_param_spec_uint ("version", "version", "version", 0, G_MAXUINT, (guint) 3, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
screen_cast_portal_instance_init (ScreenCastPortal * self,
                                  gpointer klass)
{
	self->priv = screen_cast_portal_get_instance_private (self);
	self->priv->_available_source_types = (SCREEN_CAST_SOURCE_TYPE_MONITOR | SCREEN_CAST_SOURCE_TYPE_WINDOW) | SCREEN_CAST_SOURCE_TYPE_VIRTUAL;
	self->priv->_available_cursor_modes = (SCREEN_CAST_CURSOR_MODE_HIDDEN | SCREEN_CAST_CURSOR_MODE_EMBEDDED) | SCREEN_CAST_CURSOR_MODE_METADATA;
	self->priv->_version = (guint) 3;
}

static void
screen_cast_portal_finalize (GObject * obj)
{
	ScreenCastPortal * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SCREEN_CAST_TYPE_PORTAL, ScreenCastPortal);
	_g_object_unref0 (self->priv->connection);
	_g_hash_table_unref0 (self->priv->sessions);
	G_OBJECT_CLASS (screen_cast_portal_parent_class)->finalize (obj);
}

static GType
screen_cast_portal_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ScreenCastPortalClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) screen_cast_portal_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ScreenCastPortal), 0, (GInstanceInitFunc) screen_cast_portal_instance_init, NULL };
	GType screen_cast_portal_type_id;
	screen_cast_portal_type_id = g_type_register_static (G_TYPE_OBJECT, "ScreenCastPortal", &g_define_type_info, 0);
	g_type_set_qdata (screen_cast_portal_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) screen_cast_portal_register_object);
	ScreenCastPortal_private_offset = g_type_add_instance_private (screen_cast_portal_type_id, sizeof (ScreenCastPortalPrivate));
	return screen_cast_portal_type_id;
}

GType
screen_cast_portal_get_type (void)
{
	static volatile gsize screen_cast_portal_type_id__once = 0;
	if (g_once_init_enter (&screen_cast_portal_type_id__once)) {
		GType screen_cast_portal_type_id;
		screen_cast_portal_type_id = screen_cast_portal_get_type_once ();
		g_once_init_leave (&screen_cast_portal_type_id__once, screen_cast_portal_type_id);
	}
	return screen_cast_portal_type_id__once;
}

static void
_vala_screen_cast_portal_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	ScreenCastPortal * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SCREEN_CAST_TYPE_PORTAL, ScreenCastPortal);
	switch (property_id) {
		case SCREEN_CAST_PORTAL_AVAILABLE_SOURCE_TYPES_PROPERTY:
		g_value_set_flags (value, screen_cast_portal_get_available_source_types (self));
		break;
		case SCREEN_CAST_PORTAL_AVAILABLE_CURSOR_MODES_PROPERTY:
		g_value_set_flags (value, screen_cast_portal_get_available_cursor_modes (self));
		break;
		case SCREEN_CAST_PORTAL_VERSION_PROPERTY:
		g_value_set_uint (value, screen_cast_portal_get_version (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_dbus_screen_cast_portal_create_session (ScreenCastPortal* self,
                                         GVariant* _parameters_,
                                         GDBusMethodInvocation* invocation)
{
	GVariantIter _arguments_iter;
	ScreenCastPortalCreateSessionReadyData* _ready_data;
	GVariant* _tmp440_;
	GVariant* _tmp441_;
	GVariant* _tmp442_;
	GVariant* _tmp443_;
	GHashTable* _tmp444_;
	GVariantIter _tmp445_;
	GVariant* _tmp446_;
	GVariant* _tmp447_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_ready_data = g_slice_new0 (ScreenCastPortalCreateSessionReadyData);
	_ready_data->_invocation_ = invocation;
	_tmp440_ = g_variant_iter_next_value (&_arguments_iter);
	_ready_data->handle = g_variant_dup_string (_tmp440_, NULL);
	g_variant_unref (_tmp440_);
	_tmp441_ = g_variant_iter_next_value (&_arguments_iter);
	_ready_data->session_handle = g_variant_dup_string (_tmp441_, NULL);
	g_variant_unref (_tmp441_);
	_tmp442_ = g_variant_iter_next_value (&_arguments_iter);
	_ready_data->app_id = g_variant_dup_string (_tmp442_, NULL);
	g_variant_unref (_tmp442_);
	_tmp443_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp444_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
	g_variant_iter_init (&_tmp445_, _tmp443_);
	while (g_variant_iter_loop (&_tmp445_, "{?*}", &_tmp446_, &_tmp447_)) {
		g_hash_table_insert (_tmp444_, g_variant_dup_string (_tmp446_, NULL), g_variant_get_variant (_tmp447_));
	}
	_ready_data->options = _tmp444_;
	g_variant_unref (_tmp443_);
	screen_cast_portal_create_session (self, _ready_data->handle, _ready_data->session_handle, _ready_data->app_id, _ready_data->options, (GAsyncReadyCallback) _dbus_screen_cast_portal_create_session_ready, _ready_data);
	_error:
	;
}

static void
_dbus_screen_cast_portal_create_session_ready (GObject * source_object,
                                               GAsyncResult * _res_,
                                               gpointer _user_data_)
{
	ScreenCastPortalCreateSessionReadyData* _ready_data;
	GDBusMethodInvocation* invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	guint response = 0U;
	GHashTable* results = NULL;
	GVariantBuilder _tmp448_;
	GHashTableIter _tmp449_;
	gpointer _tmp450_;
	gpointer _tmp451_;
	_ready_data = _user_data_;
	invocation = _ready_data->_invocation_;
	screen_cast_portal_create_session_finish ((ScreenCastPortal*) source_object, _res_, &response, &results, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_uint32 (response));
	g_hash_table_iter_init (&_tmp449_, results);
	g_variant_builder_init (&_tmp448_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp449_, &_tmp450_, &_tmp451_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp450_;
		_value = (GVariant*) _tmp451_;
		g_variant_builder_add (&_tmp448_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp448_));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (_ready_data->handle);
	_g_free0 (_ready_data->session_handle);
	_g_free0 (_ready_data->app_id);
	_g_hash_table_unref0 (_ready_data->options);
	_g_hash_table_unref0 (results);
	g_slice_free (ScreenCastPortalCreateSessionReadyData, _ready_data);
}

static void
_dbus_screen_cast_portal_select_sources (ScreenCastPortal* self,
                                         GVariant* _parameters_,
                                         GDBusMethodInvocation* invocation)
{
	GVariantIter _arguments_iter;
	ScreenCastPortalSelectSourcesReadyData* _ready_data;
	GVariant* _tmp452_;
	GVariant* _tmp453_;
	GVariant* _tmp454_;
	GVariant* _tmp455_;
	GHashTable* _tmp456_;
	GVariantIter _tmp457_;
	GVariant* _tmp458_;
	GVariant* _tmp459_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_ready_data = g_slice_new0 (ScreenCastPortalSelectSourcesReadyData);
	_ready_data->_invocation_ = invocation;
	_tmp452_ = g_variant_iter_next_value (&_arguments_iter);
	_ready_data->handle = g_variant_dup_string (_tmp452_, NULL);
	g_variant_unref (_tmp452_);
	_tmp453_ = g_variant_iter_next_value (&_arguments_iter);
	_ready_data->session_handle = g_variant_dup_string (_tmp453_, NULL);
	g_variant_unref (_tmp453_);
	_tmp454_ = g_variant_iter_next_value (&_arguments_iter);
	_ready_data->app_id = g_variant_dup_string (_tmp454_, NULL);
	g_variant_unref (_tmp454_);
	_tmp455_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp456_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
	g_variant_iter_init (&_tmp457_, _tmp455_);
	while (g_variant_iter_loop (&_tmp457_, "{?*}", &_tmp458_, &_tmp459_)) {
		g_hash_table_insert (_tmp456_, g_variant_dup_string (_tmp458_, NULL), g_variant_get_variant (_tmp459_));
	}
	_ready_data->options = _tmp456_;
	g_variant_unref (_tmp455_);
	screen_cast_portal_select_sources (self, _ready_data->handle, _ready_data->session_handle, _ready_data->app_id, _ready_data->options, (GAsyncReadyCallback) _dbus_screen_cast_portal_select_sources_ready, _ready_data);
	_error:
	;
}

static void
_dbus_screen_cast_portal_select_sources_ready (GObject * source_object,
                                               GAsyncResult * _res_,
                                               gpointer _user_data_)
{
	ScreenCastPortalSelectSourcesReadyData* _ready_data;
	GDBusMethodInvocation* invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	guint response = 0U;
	GHashTable* results = NULL;
	GVariantBuilder _tmp460_;
	GHashTableIter _tmp461_;
	gpointer _tmp462_;
	gpointer _tmp463_;
	_ready_data = _user_data_;
	invocation = _ready_data->_invocation_;
	screen_cast_portal_select_sources_finish ((ScreenCastPortal*) source_object, _res_, &response, &results, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_uint32 (response));
	g_hash_table_iter_init (&_tmp461_, results);
	g_variant_builder_init (&_tmp460_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp461_, &_tmp462_, &_tmp463_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp462_;
		_value = (GVariant*) _tmp463_;
		g_variant_builder_add (&_tmp460_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp460_));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (_ready_data->handle);
	_g_free0 (_ready_data->session_handle);
	_g_free0 (_ready_data->app_id);
	_g_hash_table_unref0 (_ready_data->options);
	_g_hash_table_unref0 (results);
	g_slice_free (ScreenCastPortalSelectSourcesReadyData, _ready_data);
}

static void
_dbus_screen_cast_portal_start (ScreenCastPortal* self,
                                GVariant* _parameters_,
                                GDBusMethodInvocation* invocation)
{
	GVariantIter _arguments_iter;
	ScreenCastPortalStartReadyData* _ready_data;
	GVariant* _tmp464_;
	GVariant* _tmp465_;
	GVariant* _tmp466_;
	GVariant* _tmp467_;
	GVariant* _tmp468_;
	GHashTable* _tmp469_;
	GVariantIter _tmp470_;
	GVariant* _tmp471_;
	GVariant* _tmp472_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_ready_data = g_slice_new0 (ScreenCastPortalStartReadyData);
	_ready_data->_invocation_ = invocation;
	_tmp464_ = g_variant_iter_next_value (&_arguments_iter);
	_ready_data->handle = g_variant_dup_string (_tmp464_, NULL);
	g_variant_unref (_tmp464_);
	_tmp465_ = g_variant_iter_next_value (&_arguments_iter);
	_ready_data->session_handle = g_variant_dup_string (_tmp465_, NULL);
	g_variant_unref (_tmp465_);
	_tmp466_ = g_variant_iter_next_value (&_arguments_iter);
	_ready_data->app_id = g_variant_dup_string (_tmp466_, NULL);
	g_variant_unref (_tmp466_);
	_tmp467_ = g_variant_iter_next_value (&_arguments_iter);
	_ready_data->parent_window = g_variant_dup_string (_tmp467_, NULL);
	g_variant_unref (_tmp467_);
	_tmp468_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp469_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
	g_variant_iter_init (&_tmp470_, _tmp468_);
	while (g_variant_iter_loop (&_tmp470_, "{?*}", &_tmp471_, &_tmp472_)) {
		g_hash_table_insert (_tmp469_, g_variant_dup_string (_tmp471_, NULL), g_variant_get_variant (_tmp472_));
	}
	_ready_data->options = _tmp469_;
	g_variant_unref (_tmp468_);
	screen_cast_portal_start (self, _ready_data->handle, _ready_data->session_handle, _ready_data->app_id, _ready_data->parent_window, _ready_data->options, (GAsyncReadyCallback) _dbus_screen_cast_portal_start_ready, _ready_data);
	_error:
	;
}

static void
_dbus_screen_cast_portal_start_ready (GObject * source_object,
                                      GAsyncResult * _res_,
                                      gpointer _user_data_)
{
	ScreenCastPortalStartReadyData* _ready_data;
	GDBusMethodInvocation* invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	guint response = 0U;
	GHashTable* results = NULL;
	GVariantBuilder _tmp473_;
	GHashTableIter _tmp474_;
	gpointer _tmp475_;
	gpointer _tmp476_;
	_ready_data = _user_data_;
	invocation = _ready_data->_invocation_;
	screen_cast_portal_start_finish ((ScreenCastPortal*) source_object, _res_, &response, &results, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_uint32 (response));
	g_hash_table_iter_init (&_tmp474_, results);
	g_variant_builder_init (&_tmp473_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp474_, &_tmp475_, &_tmp476_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp475_;
		_value = (GVariant*) _tmp476_;
		g_variant_builder_add (&_tmp473_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp473_));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (_ready_data->handle);
	_g_free0 (_ready_data->session_handle);
	_g_free0 (_ready_data->app_id);
	_g_free0 (_ready_data->parent_window);
	_g_hash_table_unref0 (_ready_data->options);
	_g_hash_table_unref0 (results);
	g_slice_free (ScreenCastPortalStartReadyData, _ready_data);
}

static void
screen_cast_portal_dbus_interface_method_call (GDBusConnection* connection,
                                               const gchar* sender,
                                               const gchar* object_path,
                                               const gchar* interface_name,
                                               const gchar* method_name,
                                               GVariant* parameters,
                                               GDBusMethodInvocation* invocation,
                                               gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "CreateSession") == 0) {
		_dbus_screen_cast_portal_create_session (object, parameters, invocation);
	} else if (strcmp (method_name, "SelectSources") == 0) {
		_dbus_screen_cast_portal_select_sources (object, parameters, invocation);
	} else if (strcmp (method_name, "Start") == 0) {
		_dbus_screen_cast_portal_start (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
_dbus_screen_cast_portal_get_available_source_types (ScreenCastPortal* self)
{
	ScreenCastSourceType result;
	GVariant* _reply;
	result = screen_cast_portal_get_available_source_types (self);
	_reply = g_variant_new_uint32 (result);
	return _reply;
}

static GVariant*
_dbus_screen_cast_portal_get_available_cursor_modes (ScreenCastPortal* self)
{
	ScreenCastCursorMode result;
	GVariant* _reply;
	result = screen_cast_portal_get_available_cursor_modes (self);
	_reply = g_variant_new_uint32 (result);
	return _reply;
}

static GVariant*
_dbus_screen_cast_portal_get_version (ScreenCastPortal* self)
{
	guint result;
	GVariant* _reply;
	result = screen_cast_portal_get_version (self);
	_reply = g_variant_new_uint32 (result);
	return _reply;
}

static GVariant*
screen_cast_portal_dbus_interface_get_property (GDBusConnection* connection,
                                                const gchar* sender,
                                                const gchar* object_path,
                                                const gchar* interface_name,
                                                const gchar* property_name,
                                                GError** error,
                                                gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "AvailableSourceTypes") == 0) {
		return _dbus_screen_cast_portal_get_available_source_types (object);
	} else if (strcmp (property_name, "AvailableCursorModes") == 0) {
		return _dbus_screen_cast_portal_get_available_cursor_modes (object);
	} else if (strcmp (property_name, "Version") == 0) {
		return _dbus_screen_cast_portal_get_version (object);
	}
	return NULL;
}

static gboolean
screen_cast_portal_dbus_interface_set_property (GDBusConnection* connection,
                                                const gchar* sender,
                                                const gchar* object_path,
                                                const gchar* interface_name,
                                                const gchar* property_name,
                                                GVariant* value,
                                                GError** error,
                                                gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

guint
screen_cast_portal_register_object (gpointer object,
                                    GDBusConnection* connection,
                                    const gchar* path,
                                    GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_screen_cast_portal_dbus_interface_info), &_screen_cast_portal_dbus_interface_vtable, data, _screen_cast_portal_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}

static void
_screen_cast_portal_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

